{****************************************************}
{*              File Split/UnSplit v1.4             *}
{*   Copyright (c) by Dmitry Beloshistov [-=BDS=-]  *}
{****************************************************}

{$IFNDEF VIRTUALPASCAL}
 This code for Virtual Pascal only!!!
{$ENDIF}

{$DELPHI+,H+}

Uses Dos,Crt,SysUtils,Windows;

const CLB:Array[1..7] of longint=(179200,362496,730112,1213952,1457664,2915328,0);
      CBS:Array[1..6] of string[5]=('180K','360K','720K','1.2M','1.44M','2.88M');

var Source:String;
    Swh:char;
    TrgDrive:string;
    Sfsp:boolean;
    OldAttr:word;

const OverAll:boolean=false;
      MustDie:boolean=false;  { file must die ;-) after split/unsplit }

const FB=$46;    {'F'}
      LB=$4C;    {'L'}

type
    TSig=record
          CSig:array[0..2] of char;    {signature as 'FBS',14-05-99,BDS}
          Name:array[0..261] of char;  {source filename} {25-04-2001,bds,update}
                                       {Added long file name support}
          BN:Word;                     {block number 000h - FFFh}
          WB:Byte;                     {FB or LB}
         end;

{--------------------------------------------}
Function Drives:String;
const DrivesChar:String='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var D,B:DWord;
    i:integer;
begin
 D:=GetLogicalDrives; B:=1;
 Result:=''; i:=1;
 while (B<=D) do
 begin
  if ((D and B)<>0) then Result:=Result+DrivesChar[i];
  B:=B shl 1; inc(i);
 end;
end;
{--------------------------------------------}
Function GetYN(Msg:String):boolean;
var ch:char;
begin
write(Msg);
repeat ch:=readkey; until (UpCase(ch) in ['Y','N']);
GetYN:=(UpCase(Ch)='Y');
writeln(Ch);
end;
{--------------------------------------------}
Function QRepeat(S:String):boolean;
begin
 writeln('Error reading file ',S);
 QRepeat:=GetYN('Retry? ');
end;
{--------------------------------------------}
Function HasDisk(S:String):boolean;
begin HasDisk:=((Pos(UpCase(S[1]),Drives)<>0) and (S[2]=':')); end;
{--------------------------------------------}
Function IsDiskette(Drv:Char):boolean;
{test for diskette source}
var D:array[0..3] of char;
begin
 StrPCopy(D,UpCase(Drv)+':'#0);
 Result:=(GetDriveType(D)=DRIVE_REMOVABLE);
end;
{--------------------------------------------}
Procedure Help;
begin
 writeln('Usage: fbsplit.exe filename.ext /blocksize|/U|/S|/F [/D] [/H|/?]');
 writeln(' ':10,'filename.ext - source file name');
 writeln(' ':10,'blocksize: 1 - 180Kb, 2 - 360Kb, 3 - 720Kb, 4 - 1.2Mb,');
 writeln(' ':21,'5 - 1.44Mb, 6 - 2.88Mb (Use /5 for split on 1.44M blocks)');
 writeln(' ':10,'/U - unsplit file');
 writeln(' ':10,'/D - source file after SPLIT (or file block(s) after UNSPLIT)');
 writeln(' ':15,'must be deleted from disk');
 writeln(' ':10,'/S - user defined block size');
 writeln(' ':10,'/F - SPLIT on free disk space for floppy drives');
 writeln(' ':10,'/H,/? - help');
 Halt(0);
end;
{--------------------------------------------}
Procedure Error(Er:Byte);
begin
writeln;
write('Error #',Er:2,'! ');
 case Er of
  1:writeln('Uncnown operation! Use parameters are 1..6,F,S,D,U');
  2:writeln('Source file ',ParamStr(1),' not found on disk');
  3:writeln('Incorrect parameter ',Swh);
  4:writeln('Number of all blocks more then 4096');
  5:writeln('File size of ',Source,' are low then one block length');
  6:writeln('Read/write error during split file ',Source);
  7:writeln('Error reading block file');
  8:writeln('Size of block are low then signature');
  9:writeln('Read/write error during usplit file ',Source);
 10:writeln('Block not found on disk');
 11:writeln('Incorrect parameter ',ParamStr(3));
 12:writeln('Incorrect block size ',CLB[7]);
 13:writeln('Next block for UnSplit not found on disk!');
 14:writeln('Wildcards `?` and `*` are not allowed!');
 15:writeln('Error write to file!');
 16:writeln('Error read from file!');
 end;
 Halt(Er);
end;
{--------------------------------------------}
Procedure GetUserBlock;
begin
 repeat
  begin
    if swh=#0 then writeln('Incorect data!');
    write('Enter size of one file block (in Kb) : ');
  end;
  {$I-}
  readln(CLB[7]);
  {$I+}
  if IOResult<>0 then Swh:=#0
  else Swh:=#1;
 until Swh=#1;
 if CLB[7]<=0 then Error(12);
 CLB[7]:=longint(CLB[7]*1024);
 Swh:='7';
end;
{--------------------------------------------}
Procedure GetTargetDrive;
var Drvs:String;
    ch:char;
begin
 Drvs:=Drives;
 write('Enter target drive for SPLIT or press <Esc> for quit: ');
 repeat
  ch:=readkey;
 until (Pos(UpCase(ch),Drvs)<>0) or (ch=#27);
 if ch=#27 then begin
                 writeln;
                 writeln('User break!');
                 Halt(0);
                end;
 writeln(UpCase(ch));
 TrgDrive:=UpCase(ch)+':\';
 GetDir(0,Drvs);
 if TrgDrive[1]=Drvs[1] then TrgDrive:=Drvs;
end;
{--------------------------------------------}
Function DelCh(S:String; Ch:Char):String;
begin while Pos(Ch,S)<>0 do delete(S,Pos(Ch,S),1); DelCH:=S; end;
{--------------------------------------------}
Procedure ProcessCmdLine;
var s:string;
begin
 if ParamStr(1)='' then Help;
 Source:=ParamStr(1);
 S:=UpperCase(Source);
 if (S='/?') or (S='/H') or (S='-H') or (S='-?') then Help;
 if (Pos('?',Source)<>0) or (Pos('*',Source)<>0) then Error(14);
 if not fileexists(Source) then Error(2);
 s:=ParamStr(2);
 if s='' then Error(1);
 S:=UpperCase(S);
 S:=DelCh(S,'-'); S:=DelCh(S,'/');
 Swh:=s[1];
 if (swh='?') or (UpCase(Swh)='H') then Help;
 if not(UpCase(Swh) in ['1'..'6','U','S','F']) then Error(3);

 if UpCase(Swh)='S' then GetUserBlock;
 if UpCase(Swh)='F' then begin GetTargetDrive; sfsp:=true; end
 else begin
       GetDir(0,s);
       TrgDrive:=s;
       sfsp:=false;
      end;

 s:=ParamStr(3);
 if s='' then exit; S:=DelCh(S,'-'); S:=DelCh(S,'/');
 if (s[1]='?') then Help;
 if (S='HE') or (S='H') then Help;  { 7-05-2000,BDS}
 if not (UpCase(S[1]) in ['D','C'{,'L'}]) then Error(11)
 else case UpCase(S[1]) of
        'D':MustDie:=true;
      end;
 S:=ParamStr(4);
 if s='' then exit; S:=DelCh(S,'-'); S:=DelCh(S,'/');
 if (s[1]='?') then Help;
 if (S='HE') or (S='H') then Help;  { 7-05-2000,BDS}
 if not (UpCase(S[1]) in ['D','C'{,'L'}]) then Error(11)
 else case UpCase(S[1]) of
        'D':MustDie:=true;
      end;
 S:=ParamStr(5);
 if s='' then exit; S:=DelCh(S,'-'); S:=DelCh(S,'/');
 if (s[1]='?') then Help;
 if (S='HE') or (S='H') then Help;  { 7-05-2000,BDS}
 if not (UpCase(S[1]) in ['D','C'{,'L'}]) then Error(11)
 else case UpCase(S[1]) of
        'D':MustDie:=true;
      end;
end;
{--------------------------------------------}
Function Uspl:boolean;
begin
 USpl:=(UpCase(Swh)='U'); {split as default}
end;
{--------------------------------------------}
Function BSize:byte;
begin
 BSize:=lo(StrToInt(UpCase(Swh)));
end;
{--------------------------------------------}
Procedure InitSig(BlkNum:Word; IsLast:Boolean; var Sig:TSig);
var D:DirStr; N:NameStr; E:ExtStr;
begin
 FSplit(Source,D,N,E);
 FillChar(Sig,SizeOf(TSig),#0);
 with Sig do
  begin
   StrPCopy(CSig,'FBS');  {14-05-99,BDS}
   StrPCopy(Name,N+E);
   BN:=BlkNum;
   if IsLast then WB:=LB else WB:=FB;
  end;
end;
{--------------------------------------------}
Function GetNextName(BlkNum:Word):string;
begin
 GetNextName:=ChangeFileExt(Source,'.'+IntToHex(BlkNum,3));
end;
{--------------------------------------------}
Function GetAns(Msg:String):boolean;
var Ch:Char;
begin
 write(Msg);
 repeat
  ch:=readkey;
 until UpCase(Ch) in ['Y','N','A'];
 writeln(UpCase(Ch));
 case UpCase(ch) of
  'Y':GetAns:=true;
  'N':GetAns:=false;
  'A':begin GetAns:=true; OverAll:=true; end;
 end;
end;
{--------------------------------------------}
Function OverWrt(FName:String):boolean;
begin
 if not OverAll then
  begin
   if FileExists(FName) then
     OverWrt:=GetAns('File '+FName+' already exist. Overwrite? (Yes | No | All) ')
   else OverWrt:=true;
  end
 else OverWrt:=true;
end;
{--------------------------------------------}
type PByteArray=^TByteArray;
     TByteArray=array[0..65530] of Byte;
{--------------------------------------------}
Function GetDriveNum(Drv:Char):byte;
var Drvs:String;
begin
 Drvs:=Drives;
 GetDriveNum:=Pos(UpCase(Drv),Drvs);
end;
{--------------------------------------------}
Procedure ZeroSig(var Sig:TSig);
begin
 FillChar(Sig,SizeOf(TSig),0);
end;
{--------------------------------------------}
Function GFSize(FileName:String):longint;
var Sr:TSearchRec;
begin
 if SysUtils.FindFirst(FileName,AnyFile-VolumeID-Directory,Sr)=0 then GFSize:=Sr.Size
 else GFSize:=-1;
 SysUtils.FindClose(Sr);
end;
{--------------------------------------------}
Function DLS(S:String):String;
begin
 while (S<>'') and (S[length(S)]='\') do delete(S,Length(S),1);
 Dls:=S;
end;
{--------------------------------------------}
procedure LowPrec(var A, B: LongInt);
begin
  while (A > $FFFF) or (B > $FFFF) do
  begin
    A := A shr 2;
    B := B shr 2;
  end;
end;
{--------------------------------------------}
Function Strg(Ch:Char; Len:byte):String;
var S:String;
begin
 S:=''; while Length(S)<Len do S:=S+ch;
 Strg:=S;
end;
{--------------------------------------------}
function StrGrd(AMax, ACur: LongInt; Wide: Byte): string;
var
  A: Byte;
begin
  LowPrec(AMax, ACur);
  if AMax = 0 then A := Wide else A := (ACur*Wide) div AMax;
  StrGrd := Copy(Strg(#219,A)+Strg(#177, Wide), 1, Wide);
end;
{--------------------------------------------}
function Percent(AMax, ACur: LongInt): LongInt;
begin
  LowPrec(AMax, ACur);
  if AMax = 0 then Percent := 0 else Percent := (ACur*100) div AMax;
end;
{--------------------------------------------}
Procedure SplitFreeSpace;
var CurBlk:Word;
    Buffer:PByteArray;
    Sig:TSig;
    L:Longint;
    Fs,Ft:File;
    Rb,Wb:Word;
    Er:Byte;
    Dnum:byte;
    CSize:longint;
    D:DirStr;
    E:ExtStr;
    N:NameStr;
    T:String;
    MaxP,CurP:Longint;
    Px,Py:byte;
     {--------------------------------------------}
Procedure GetNextDisk(firstflag:boolean);
label l1;
var ch:Char;
begin
l1:
 case firstflag of
  false:writeln('Insert next disk into drive ',T[1],': and press Enter for continue (Esc - abort)');
  true :writeln('Insert first disk into drive ',T[1],': and press Enter for continue (Esc - abort)');
 end;

repeat
 ch:=readkey;
until ch in [#13,#27];
if ch=#27 then begin writeln('User break!'); halt(0); end;
if DiskFree(DNum)<=SizeOf(TSig) then
 begin
  writeln('This disk full! ',DiskFree(DNum):12,' bytes free.');
  goto l1;
 end;
end;
     {--------------------------------------------}
     Procedure TestError(WRB:boolean);
     begin
      if not WRb then
       begin
        close(fs);
        close(ft);
        Error(6);
       end;
     end;
    {--------------------------------------------}
begin
 GetNextDisk(true);
 Dnum:=GetDriveNum(TrgDrive[1]);
 if GFSize(Source)<=DiskFree(DNum) then Error(5);
 Assign(Fs,Source);
 FileMode:=0;            {ReadOnly mode}
 repeat
 {$I-}
 reset(fs,1);
 {$I+}
 if IOResult<>0 then if not QRepeat(Source) then Error(16);
 until IOResult=0;
 CSize:=FileSize(fs);
 CurBlk:=0;
 repeat
   T:=GetNextName(CurBlk);
   FSplit(t,D,N,E);
   T:=Dls(TrgDrive)+'\'+N+E;
   ZeroSig(Sig);
   if not OverWrt(T) then
     begin
      close(fs);
      Halt(0);
     end;
   Assign(ft,T);
   repeat
    {$I-}
    rewrite(ft,1);
    {$I+}
    if IOResult<>0 then if not QRepeat(T) then Error(15);
   until IOResult=0;
   writeln('Create block ',T);              {29-12-99}
   BlockWrite(ft,Sig,Sizeof(TSig),Wb);
   TestError((Wb=SizeOf(TSig)));
   New(Buffer);
   {---------------------------------------------}
   CurP:=0; MaxP:=DiskFree(DNum); Px:=WhereX; Py:=WhereY;
   Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
   {---------------------------------------------}
   repeat
    if DiskFree(DNum)>=SizeOf(TByteArray) then Wb:=SizeOf(TByteArray)
    else Wb:=DiskFree(DNum);
    BlockRead(fs,Buffer^,Wb,Rb);
    BlockWrite(ft,Buffer^,Rb,Wb);
    TestError((Wb=Rb));
    dec(CSize,Wb);
    {---------------------------------------------}
    inc(CurP,Wb);
    GotoXY(Px,Py);
    Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
    {---------------------------------------------}
   until (DiskFree(DNum)=0) or (CSize=0);
   writeln;
   Dispose(Buffer);
   close(ft);
   repeat
   {$I-}
   reset(ft,1);
   {$I+}
   if IOResult<>0 then if not QRepeat(T) then Error(15);
   until IOResult=0;
   InitSig(CurBlk,(CSize=0),Sig);
   blockwrite(ft,sig,sizeof(sig),wb);
   TestError((wb=sizeof(tsig)));
   close(ft);
   writeln('Block ',T,' ',GFSize(T):12,' byte(s)',' ':10,'Ok!');
   inc(curblk);
   if (CSize<>0) then GetNextDisk(false);
 until CSize<=0;
 close(fs);
 if MustDie then SysUtils.DeleteFile(Source)
 else SetFAttr(fs,OldAttr);
 writeln;
 writeln('File ',Source,' split complete');
end;
{--------------------------------------------}
Procedure Split;
var CurBlk:Word;
    Buffer:PByteArray;
    Sig:TSig;
    LBlk:Longint;
    ABlk:Word;
    LBS:Longint;
    Fs,Ft:File;
    Rb,Wb:Word;
    CSize:Longint;
    Er:Byte;
    MaxP,CurP:Longint;
    Px,Py:byte;
     {--------------------------------------------}
     Procedure TestError(WRB:boolean);
     begin
      if not WRb then
       begin
        close(fs);
        close(ft);
        Error(6);
       end;
     end;
    {--------------------------------------------}
begin
 LBlk:=CLB[BSize]-SizeOf(TSig);          {   ( ᫥)}
 if GFSize(Source)<=LBlk then Error(5);
 ABlk:=GFSize(Source) div LBlk;     {᫮ }
 LBS:=(GFSize(Source) mod LBlk);    {ࠧ ᫥ }
 if LBS<>0 then inc(ABlk);
 if ABlk>$0FFF then Error(4);
 Assign(Fs,Source);
 FileMode:=0;  {ReadOnly mode}
 repeat
 {$I-}
 reset(fs,1);
 {$I+}
 if IOResult<>0 then if not QRepeat(Source) then Error(16);
 until IOResult=0;
 For CurBlk:=0 to (ABlk-1) do
  begin
   if CurBlk=(ABlk-1) then CSize:=LBS+SizeOf(TSig) else CSize:=LBlk+SizeOf(TSig);
   InitSig(CurBlk,(CurBlk=(ABlk-1)),Sig);
   if not OverWrt(GetNextName(CurBlk)) then
     begin
      close(fs);
      Halt(0);
     end;
   Assign(ft,GetNextName(CurBlk));
   repeat
    {$I-}
    rewrite(ft,1);
    {$I+}
    if IOResult<>0 then if not QRepeat(GetNextName(CurBlk)) then Error(15);
   until IOResult=0;
   writeln('Create block ',GetNextName(CurBlk)); {29-12-99}
   BlockWrite(ft,Sig,Sizeof(TSig),Wb);
   TestError((Wb=SizeOf(TSig)));
   dec(CSize,Wb);
   New(Buffer);
   {---------------------------------------------}
   CurP:=0; MaxP:=CSize; Px:=WhereX; Py:=WhereY;
   Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
   {---------------------------------------------}
   repeat
    if CSize>SizeOf(TByteArray) then Wb:=SizeOf(TByteArray)
    else Wb:=CSize;
    BlockRead(fs,Buffer^,Wb,Rb);
    TestError((Wb=Rb));
    BlockWrite(ft,Buffer^,Rb,Wb);
    TestError((Wb=Rb));
    dec(CSize,Wb);
    {---------------------------------------------}
    inc(CurP,Wb);
    GotoXY(Px,Py);
    Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
    {---------------------------------------------}
   until CSize=0;
   Dispose(Buffer);
   close(ft);
   writeln;
   writeln('Block ',GFSize(GetNextName(CurBlk)):12,' byte(s)',' ':10,'Ok!');
  end;
 close(fs);
 if MustDie then SysUtils.DeleteFile(Source)
  else SetFAttr(fs,OldAttr);
 writeln;
 writeln('File ',Source,' split complete');
end;
{--------------------------------------------}
var ExtrFile:String;
{--------------------------------------------}
Procedure ReadSig(BlkFile:String; var Sig:TSig);
var f:file;
    Rb:Word;
begin
 Assign(f,BlkFile);
 FileMode:=0;
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult<>0 then Error(7);
 if FileSize(f)<SizeOf(TSig) then begin
                                   close(f);
                                   Error(8);
                                  end;
 BlockRead(f,Sig,SizeOf(TSig),Rb);
 if Rb<>SizeOf(TSig) then Error(7);
 close(f);
end;
{--------------------------------------------}
Function IsCorrectBlock(Sig:TSig; ReqBlk:Word):boolean;
var B:Boolean;
    s:string;
    i:integer;
    D:DirStr; {03-09-99,BDS}
    N:NameStr;
    E:ExtStr;
begin
  s:='';
  for i:=0 to 261 do
    if Sig.Name[i]=#0 then break
    else s:=s+Sig.Name[i];
  FSplit(ExtrFile,D,N,E);             {03-09-99,BDS}
  B:=(N+E=S);
  s:='';                              {14-05-99,BDS}
  for i:=0 to 2 do s:=s+Sig.CSig[i];
  B:=B and (s='FBS');
  B:=B and (ReqBlk=Sig.BN);
  IsCorrectBlock:=B;
end;
{--------------------------------------------}
Function IsLB(Sig:TSig):boolean;
begin
 IsLB:=(Sig.WB=LB);
end;
{--------------------------------------------}
Function DiskRequest(ReqBlock:word):boolean;
var ch:char;
begin
 writeln('Please insert disk #',ReqBlock,' (',IntToHex(ReqBlock,3),') and press <Enter> ',
       'for continue or <Esc> for quit...');
 repeat
  ch:=readkey;
 until ch in [#13,#27];
 DiskRequest:=(ch=#13);
end;
{--------------------------------------------}
Procedure UnSplit;
label l1,l2;
var Fs,Ft:File;
    Rb,Wb:Word;
    Buffer:PByteArray;
    CurBlk:Word;
    BlkName:string;
    Sig:TSig;
    Er:Byte;
    TargetDir:String;
    MaxP,CurP:Longint;
    Px,Py:byte;
    {--------------------------------------------}
     Procedure TestError(WRB:Boolean);
     begin
      if WRB then
       begin
        close(fs);
        close(ft);
        Error(9);
       end;
     end;
    {--------------------------------------------}
begin
 GetDir(0,TargetDir);
 CurBlk:=0;
 BlkName:=GetNextName(CurBlk);
if (HasDisk(BlkName) and isDiskette(BlkName[1])) then
 BEGIN
 if not FileExists(BlkName) then
  repeat
   if not Diskrequest(CurBlk) then goto l2;
  until FileExists(BlkName);
 END
else begin if not FileExists(BlkName) then Error(10); end;
 ReadSig(BlkName,Sig); ExtrFile:=StrPas(Sig.Name);
 ExtrFile:=dls(TargetDir)+'\'+ExtrFile; {target path and file}
 if not GetYN('Unsplit to file '+ExtrFile+'? (Y|N) ') then exit;
 if not OverWrt(ExtrFile) then Halt(0);
 Assign(ft,ExtrFile);
 repeat
  {$I-}
  rewrite(ft,1);
  {$I+}
  if IOResult<>0 then if not QRepeat(ExtrFile) then Error(15);
 until IOResult=0;
 repeat
l1:
  ReadSig(BlkName,Sig);
  if IsCorrectBlock(Sig,CurBlk) then
   begin
    writeln('Restoring from block ',BlkName);
    Assign(fs,BlkName);
    FileMode:=0;
    repeat
    {$I-}
    reset(fs,1);
    {$I+}
    if IOResult<>0 then if not QRepeat(BlkName) then Error(15);
    until IOResult=0;
    BlockRead(fs,Sig,SizeOf(TSig),Rb);
    New(Buffer);
   {---------------------------------------------}
    CurP:=0; MaxP:=FileSize(Fs)-SizeOf(TSig); Px:=WhereX; Py:=WhereY;
    Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
   {---------------------------------------------}
    repeat
     BlockRead(fs,Buffer^,SizeOf(TByteArray),Rb);
     BlockWrite(ft,Buffer^,Rb,Wb);
     TestError((Rb<>Wb));
     {---------------------------------------------}
     inc(CurP,Wb);
     GotoXY(Px,Py);
     Write('         ',StrGrd(MaxP,CurP,50)); write(Percent(MaxP,CurP):5,'%');
     {---------------------------------------------}
    until (Rb=0);
    Dispose(Buffer);
    close(fs);
    writeln;
    writeln('Block ',GFSize(BlkName):12,' byte(s)',' ':10,'Ok!');
    if MustDie then SysUtils.DeleteFile(BlkName);
   end
  else begin
         if HasDisk(BlkName) and (not isDiskette(BlkName[1])) then begin
                                              close(ft); Error(10);
                                            end
         else begin
               if DiskRequest(Sig.BN) then goto l1
               else begin
                    l2:
                     writeln('User break!');
                     close(ft);
                     erase(ft);
                     halt(0);
                    end;
              end;
       end;
  if not IsLB(Sig) then       {03-09-99,BDS}
   BEGIN
      Inc(CurBlk);
      BlkName:=GetNextName(CurBlk);
       if HasDisk(BlkName) and isDiskette(BlkName[1]) then
         begin
          if not DiskRequest(CurBlk) then goto l2;
         end
       else if not FileExists(BlkName) then Error(13);
   END;
 until IsLB(Sig);
 close(ft);
 writeln;
 writeln('File restoring ',ExtrFile,' complete');
end;
{--------------------------------------------}
var Quest:String;
begin
 writeln('File split/unsplit v1.4 (c) 1999-2001 by Dmitry Beloshistov [-=BDS=-]');
 writeln('E-mail: torin@scm.com.ua');
 writeln;
 ProcessCmdLine;
 if Uspl then Unsplit
 else BEGIN
 IF Sfsp THEN
  begin
   Quest:='Split file '+Source+' to all free space on disk(s)? (Y/N)';
   if GetYN(Quest) then begin
                         writeln;
                         SplitFreeSpace;
                        end;
  end
 ELSE BEGIN
        if (Swh<>'7') then Quest:='Split file '+Source+' to '+CBS[BSize]+' block(s)? (Y|N)'
        else Quest:='Split file '+Source+' to '+IntToStr(CLB[7] div 1024)+' byte(s) block(s)? (Y/N)';
       if GetYN(Quest) then
        begin
         writeln;
         Split;
        end;
      END;
     END;
 writeln(' ');
end.
